#!/bin/sh
# Run this to generate all the initial configure script , etc.

srcdir=`dirname $0`
test -z "$srcdir" && srcdir=.

DIE=0

(test -f $srcdir/configure.ac) || {
    echo -n "**Error**: Directory "\`$srcdir\'" does not look like the"
    echo " top-level package directory"
    exit 1
}

(autoconf --version) < /dev/null > /dev/null 2>&1 || {
  echo
  echo "**Error**: You must have \`autoconf' installed."
  echo "Download the appropriate package for your distribution,"
  echo "or get the source tarball at ftp://ftp.gnu.org/pub/gnu/"
  DIE=1
}


(automake --version) < /dev/null > /dev/null 2>&1 || {
  echo
  echo "**Error**: You must have \`automake' installed."
  echo "You can get it from: ftp://ftp.gnu.org/pub/gnu/"
  DIE=1
  NO_AUTOMAKE=yes
}


# if no automake, don't bother testing for aclocal
test -n "$NO_AUTOMAKE" || (aclocal --version) < /dev/null > /dev/null 2>&1 || {
  echo
  echo "**Error**: Missing \`aclocal'.  The version of \`automake'"
  echo "installed doesn't appear recent enough."
  echo "You can get automake from ftp://ftp.gnu.org/pub/gnu/"
  DIE=1
}

if test "$DIE" -eq 1; then
  exit 1
fi


dr=$srcdir
cd $dr

echo "Running aclocal ...   to generate aclocal.m4"
aclocal
echo "Running autoheader...  to generate config.h.in"
autoheader
echo "Running automake $am_opt ...   to generate Makefile.in"
if ! automake --add-missing $am_opt; then
  echo "automake failed"
  exit 1
fi
echo "Running autoconf ...   to generate configure script"
if ! autoconf; then
  echo "autoconf failed"
  exit 1
fi

echo
echo
echo Now type: ./configure --prefix=$HOME --srcdir=$PWD
echo to install program in your home directory.
echo
echo Read INSTALL file to modify the default.
echo

#echo
#echo Now type  ./configure  to install program in your home directory.
#echo Read INSTALL file to modify the default.
#echo
