!corr! ----------------------------------------------------------------------
!corr      subroutine MolPlo()
!corr      USE Molcom
!corr      USE drawatoms
!corr      implicit none
!corr!
!corr      if (jscreen > 0) then
!corr          call draw_xyzs()
!corr      endif
!corr!
!corr      return
!corr      end
! ----------------------------------------------------------------------
      subroutine CreaLab(i,j,lnz,Label)
      USE General
      USE Atomi
      USE Molcom
!
!-- i     position in array
!-- j     digits in Label string
!-- lnz   atomic species pointer
!-- Label Label string
!
!
      character*(*) Label
      character*17  Buffer
!
!corr      fy = FntPixHeight
      kser = i
!
      Buffer = ' '
      if (lnz.ne.0) then
          vetSpec(lnz) = vetSpec(lnz) + 1
          kser = vetSpec(lnz)
          if (lnz /= PiccoFour) then
              Buffer(1:2) = celem(lnz)%lab(1:2)
          else
              Buffer(1:2) = '  '
          end if
      else
          Buffer(1:2)='Q '
          vetSpec(PiccoFour) = vetSpec(PiccoFour) + 1
          kser = vetSpec(PiccoFour)
      endif
      call ucase(Buffer(1:1))
      if (Buffer(2:2).eq.' ') then
         k=2
      else
         k=3
      endif
!
      write(Buffer(k:k+4),'(i5)') kser
      call NoBlanks(Buffer,lstri)
      Label=Buffer(1:lstri)
!
      return
      end
! -----------------------------------------------------------------
!CORR      subroutine InvRm
!CORR      USE General
!CORR      USE Molcom
!CORR!
!CORR      double precision det
!CORR!
!CORR      det = 0
!CORR      i = 1
!CORR      l = i + 1
!CORR      l1 = l + 1
!CORR      do j=1, 3
!CORR         k = 1
!CORR         if (k .eq. j) then
!CORR            k = k + 1
!CORR         end if
!CORR         k1 = k + 1
!CORR         if (k1 .eq. j) then
!CORR            k1 = k1 + 1
!CORR         end if
!CORR         s = (-1.)**(i+j)
!CORR         sdet = s*rm(i,j)*(rm(l,k) * rm(l1,k1)-rm(l,k1)*rm(l1,k))
!CORR         det = det + sdet
!CORR      enddo
!CORR!
!CORR      do i=1, 3
!CORR         l=1
!CORR         if (l .eq. i) then
!CORR            l = l + 1
!CORR         end if
!CORR         l1 = l + 1
!CORR         if (l1 .eq. i) then
!CORR            l1 = l1 + 1
!CORR         end if
!CORR         do j=1, 3
!CORR            k = 1
!CORR            if (k .eq. j) then
!CORR               k = k + 1
!CORR            end if
!CORR            k1 = k + 1
!CORR            if (k1 .eq. j) then
!CORR               k1 = k1 + 1
!CORR            end if
!CORR            s = (-1.) ** (i + j)
!CORR            rmi(j,i) = (rm(l,k) * rm(l1,k1) - rm(l,k1) * rm(l1,k)) / det
!CORR            rmi(j,i) = s * rmi(j,i)
!CORR         enddo
!CORR      enddo
!CORR!
!CORR!corr  100 format (3f15.8)
!CORR      return
!CORR      end
! -----------------------------------------------------------------
      subroutine MakeLab(iniz,ifin)
      USE General
      USE Atomi
      USE Molcom
!
      vetSpec(:) = 0
      do i = iniz, ifin
          knz = nz(i) / nzConst
          lnz = iabs(knz)
          call CreaLab(i,-1,lnz,Labb)
          aLab(i) = Labb
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine InvMat(rm, rmi, iCod)
!
      USE General
      real rm(3,3),rmi(3,3)
      double precision det
!
      det = 0
      i = 1
      l = i + 1
      l1 = l + 1
      do 10 j=1, 3
         k = 1
         if (k .eq. j) then
            k = k + 1
         end if
         k1 = k + 1
         if (k1 .eq. j) then
            k1 = k1 + 1
         end if
         s = (-1.)**(i+j)
         sdet = s*rm(i,j)*(rm(l,k) * rm(l1,k1)-rm(l,k1)*rm(l1,k))
         det = det + sdet
   10 continue
c       write(lo,'(a,e15.4)')'det=',det
c      if (abs(det) .lt.0.0000001) then
      if (abs(det) .lt.1.0e-15) then
         iCod = 0
         return
      end if
!
      do 30 i=1, 3
         l=1
         if (l .eq. i) then
            l = l + 1
         end if
         l1 = l + 1
         if (l1 .eq. i) then
            l1 = l1 + 1
         end if
         do 20 j=1, 3
            k = 1
            if (k .eq. j) then
               k = k + 1
            end if
            k1 = k + 1
            if (k1 .eq. j) then
               k1 = k1 + 1
            end if
            s = (-1.) ** (i + j)
            rmi(j,i) = (rm(l,k) * rm(l1,k1) - rm(l,k1) * rm(l1,k)) / det
            rmi(j,i) = s * rmi(j,i)
   20    continue
   30 continue
      iCod = 1
!
  100 format (3f15.8)
      return
      end
! -----------------------------------------------------------------
      subroutine StampaOutputV2(ier)
      USE General
      character*256 line
!
      l = Lung(fname(OUT_FILE))
      if (l == 0) then
          Msg = 'No output file at the moment, try later.'
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
      nLines = 0
      rewind lo
  100 continue
      read(lo,'(a)',end=200) line
      write(iscra,'(a)') line(1:Lung(line))
      nLines = nLines + 1
      go to 100
!
  200 continue
      close(lo)
      rewind iscra
!
      itype=0
      iform=1
      if (jopen(lo,fname(OUT_FILE),itype,iform,ier2).lt.0) go to 1000
      do irec=1,nLines
         read(iscra,'(a)') line
         k = Lung(line)
         if (k.eq.0) k = 1
         write(lo,'(a)') line(1:k)
      enddo
!
      return
!
 1000 continue
      write(Msg,1100) ier2,fname(OUT_FILE)(1:Lung(fname(OUT_FILE)))
 1100 format(' Open error #',i5,' on file:',a)
      call MsgWinErr('ERROR', Msg, SEVERE_ERR_WINDOW, nExitCode)
      return
      end
