      MODULE TestStuff
             complex, allocatable :: FT(:)
      END MODULE TestStuff

      subroutine examin(nuset,khl,iphiv,iphic,mmm,numbx,wtexa,
     *                  ifmin_input)
      USE General, only: spacegr
      USE Symmetry, only: xyzmax,if3den,ifRhombAx,latt
      USE TestStuff, only: FT
      USE PhaseModule, only: erore,erorepes,ifExamin,ifTime
c
c-- nuset= trial ( or set ) number
c-- khl   = h-k-l array
c-- iphiv = published phases array
c-- iphic = computed phases array
c-- mmm   = number of reflections
c-- numbx = number of reflections to exclude at beginning of array
c-- wtexa = weights array
c-- shiftexam = Shifts su h,k,l and enantiomorph
c           phaseN =  sign(enantiomorph) * phaseO - 360 * ( H S )

C COMPARE CALCULATED PHASES WITH PUBLISHED VALUES (IN DEGREES), TAKING
C INTO
C ACCOUNT ANY POSSIBLE SHIFT OF ORIGIN. NOX, NOY AND NOZ ARE THE NUMBER
C OF
C POSSIBLE ORIGIN POSITIONS IN EACH DIRECTION. THESE NUMBERS MUST BE
C POWERS
C OF 2 AND NOX*NOY*NOZ MUST BE .LE. 1024. FOR DIRECTIONS ALONG WHICH THE
C ORIGIN IS COMPLETELY FREE IT IS SUGGESTED ONE SHOULD USE ABOUT 10
C TIMES
C AS MANY POINTS AS THE LENGTH OF THE CORRESPONDING CELL PARAMETER.
C EG. FOR P2(1)2(1)2(1)                  USE 2   2   2
C         P2(1) WITH B=11.0 ANGSTROM         2 128   2
C WE ACKNOWLEDGE HERE THE USE OF A FFT ROUTINE WRITTEN BY DR.A.LIFCHITZ
C FROM LABORATOIRE DE MINERALOGIE-CRISTALLOGRAPHIE, UNIVERSITE DE PARIS
C FRANCE.
C
C
C RMSE = ROOT MEAN SQUARE ERROR IN DEGREES
C ERM  = MEAN ERROR IN DEGREES
      implicit none
      integer, intent(in) :: nuset,ifmin_input,numbx,mmm
      DIMENSION khl(3,mmm),iphiv(mmm),iphic(mmm),wtexa(mmm)
      integer :: khl,iphiv,iphic
      real :: wtexa
      integer steps(3)
      integer, parameter :: FTSIZE = 2097152  !128*128*128
      integer :: ifmin,NOX,NOY,NOZ
!
      ifmin = ifmin_input
      erore    = 0.0
      erorepes = 0.0
!      ifExamin = 0            !pgMAD6
!corr-devi chiamare la examin anche se knw = 0 
!corr if (ifExamin.eq.0.or.knw.eq.0.or.ifTime.eq.1) then
      if (ifExamin.eq.0.or.ifTime.eq.1) then
          return
      endif
!corr      if (nsym.eq.1.and.icent.eq.0.and.ifReduced.eq.0) then
!corr!pgMAD4
!corr!!!!!     if (ifPatt.eq.0.and.kmad.eq.0) return    ! commentare per 
!corr!                                                    testare il P 1
!corr!pgMAD4
!corr      endif
!
      !if (sum( vpol(1:3) ) > 0) then
      if (spacegr%polar()) then
!corr          if (ifReduced.eq.1) then
!corr              if (ifmin < 9) then
!corr                  return
!corr              else
!corr                  ifmin = ifmin - 10
!corr                  nOrigRoxi = 1
!corr                  NOX = 128  !256
!corr                  NOY = 128  !256
!corr                  NOZ = 128  !256
!corr                  tabo(1,1:3) = 128  !256
!corr                  if3den = 0
!corr              endif
!corr          else
              if (ifmin > 9) then
                  ifmin = ifmin - 10
              endif
              NOX = nint( xyzmax(1) )
              NOY = nint( xyzmax(2) )
              NOZ = nint( xyzmax(3) )
!corr          endif
          if (if3den.eq.1) then
              !if (vpol(1) == 0 .and. xyzmax(1) > 4) then
              if (.not.spacegr%polarx .and. xyzmax(1) > 4) then
                  NOX = 128
                  steps(1) = 42
              else
                  steps(1) = 1
              endif
              !if (vpol(2) == 0 .and. xyzmax(2) > 4) then
              if (.not.spacegr%polary .and. xyzmax(2) > 4) then
                  NOY = 128
                  steps(2) = 42
              else
                  steps(2) = 1
              endif
              !if (vpol(3) == 0 .and. xyzmax(3) > 4) then
              if (.not.spacegr%polarz .and. xyzmax(3) > 4) then
                  NOZ = 128
                  steps(3) = 42
              else
                  steps(3) = 1
              endif
              if (ifRhombAx == 0 .and. latt == 7) then
                  steps(3) = 1
              endif
          else
              steps(1:3) = 1
          endif
!
          if (.not.allocated(FT)) allocate(FT(FTSIZE))
          CALL FERROR(FT,NOX,NOY,NOZ,steps,khl,iphiv,iphic,mmm,numbx,
     *            wtexa,nuset,ifmin)
      else
          if (allocated(FT)) deallocate(FT)
          call Esamina(khl,iphiv,iphic,mmm,numbx,wtexa,nuset,ifmin)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Esamina(khl,ipub,iphic,mmm,numbx,wtexa,nuset,ifmin)
      USE General, only: Buffer1, lo, nstr, kmad
      USE Symmetry, only: tabo, nOrigRoxi
      USE PhaseModule, only: isumal,setmin,isumalmin,ermpes1
     *,ermpes2,erm1,erm2,shiftexam,erm1min,erore,erorepes,sumalfa
      USE strutil, only: Lung
      implicit none
      integer, intent(in) :: mmm,nuset,ifmin,numbx
      integer :: i,k,ll
      real :: dxm, dym, dzm
      real :: dxmAbs, dymAbs, dzmAbs, delta, del1, del2
      real :: phih, ermpes, erm, ermAbs, erpAbs, sm
c
      integer khl(3,mmm),ipub(mmm),iphic(mmm)
      real wtexa(mmm)
      real s(6)
      character *80 Buffer2
!
      Buffer1 = ' '
      Buffer2 = ' '
      do i=1, 2
         if (i == 1) then
             sm = +1
         else
             sm = -1
         endif
         ermAbs = 9999
         erpAbs = 9999
         do k=1, nOrigRoxi
            dxm = tabo(k, 1)
            dym = tabo(k, 2)
            dzm = tabo(k, 3)
            isumal = 0
            sumalfa = 0.0
            erm = 0.0
            ermpes = 0.0
            do ll=numbx+1, mmm
               if (wtexa(ll) > 0.0) then
                   isumal = isumal + 1
                   sumalfa = sumalfa + wtexa(ll)
                   phih = iphic(ll)
                   delta = (khl(1,ll) * dxm
     *                    + khl(2,ll) * dym
     *                    + khl(3,ll) * dzm) 
                   del1= 360.0 * delta + ipub(ll) -sm * iphic(ll)
!                  del1 = 360.0 * (jh * dxm + jk * dym + jl * dzm)
!    *                  + ipub(ll) - sm * ifaz
                   del2 = abs( amod(del1, 360.0) )
                   if (del2 > 180.0) del2 = 360.0 - del2
                   erm = erm + del2
                   ermpes = ermpes + del2 * wtexa(ll)
!     write(6,1000) ll,khl(1:3,ll),iphic(ll),ipub(ll),dxm,dym,dzm,delta,
!    *              del1,del2,erm,ermpes
!1000 format(i4,1h),5i4,3f6.3,2f12.3,f8.3,2f15.3)
               endif
            enddo
            if (isumal > 0) then
                erm = erm/isumal
                ermpes = ermpes/sumalfa
            else
               return
            endif
            if (erm < ermAbs) then
                ermAbs = erm
                dxmAbs = dxm
                dymAbs = dym
                dzmAbs = dzm
                erpAbs = ermpes
            endif
         enddo
         if (i == 1) then
             erm1 = ermAbs
             ermpes1 = erpAbs
             s(1) = dxmAbs
             s(2) = dymAbs
             s(3) = dzmAbs
! 
             if (kmad == 0) then
                 write(Buffer1(1:40),"(i5,') ',3f5.2,2f8.2,'  ')") 
     *                 nuset, s(1:3), erm1, ermpes1
             else
                 write(Buffer1(1:46),"(i5,') ',3f5.2,2f11.5,'  ')")
     *                 nuset, s(1:3), erm1, ermpes1
             endif
             write(Buffer2(1:31),"(i6,')',2f9.2,'      ')") nuset,
     *                   erm1, ermpes1
             if (erm1 < erm1min .and. isumal > nstr/2) then
                 setmin = nuset
                 erm1min = erm1
                 isumalmin=isumal
             endif
         else
             erm2 = ermAbs
             ermpes2 = erpAbs
             s(4) = dxmAbs
             s(5) = dymAbs
             s(6) = dzmAbs
! 
             if (kmad == 0) then
                 write(Buffer1(41:),'(3f5.2,2f8.2,i6)')
     *                      s(4:6),erm2, ermpes2, isumal
             else
                 write(Buffer1(47:),'(3f5.2,2f11.5,i6)')
     *                      s(4:6),erm2, ermpes2, isumal
             endif
             if (erm2 < erm1min .and. isumal > nstr/2) then
                 setmin = -nuset
                 erm1min = erm2
                 isumalmin=isumal
             endif
         endif
         write(Buffer2(32:),'(2f9.2,i6,f9.2,i6)')
     *                   erm2,ermpes2,isumal,erm1min,nint(setmin)
      enddo
      if (erm1 > erm2) then
          erore = erm2
          erorepes = ermpes2
         do i=1,3
            shiftexam(i) = s(i+3)
            shiftexam(i+4) = s(i)
         end do
         shiftexam(4) = -1.0
      else
          erore = erm1
          erorepes = ermpes1
         do i=1,3
            shiftexam(i) = s(i)
            shiftexam(i+4) = s(i+3)
         end do
         shiftexam(4) = 1.0
      end if
      if (ifmin /= 0) then
         write(lo,'(a)') Buffer1(1:Lung(Buffer1))
!corr         call toflush()
      end if
!
      return
      end
!-----------------------------------------------------------------------
      SUBROUTINE FERROR(FT,NOX,NOY,NOZ,steps,khl,ipub,iphic,mmm,
     *                  numbx,wtexa,nuset,ifmin)
      USE General, only: Buffer1,dtor,spacegr,kmad,lo,nstr
      USE Symmetry, only: ifRhombAx,nOrigRoxi,if3den,tabo
      USE PhaseModule, only: sumalfa,ISUMAL,ERM1,ERM2,ermpes1,
     *ermpes2,shiftexam,setmin,isumalmin,erm1min,erorepes,erore
      USE strutil, only: Lung
!
      implicit none
      integer, intent(in) :: NOX,NOY,NOZ,mmm
      dimension khl(3,mmm),ipub(mmm),iphic(mmm)
      integer :: khl,ipub,iphic,numbx,ifmin
      real, dimension(mmm) :: wtexa
      real, dimension(:) :: s(6),dxyzi(3),dxyz(3)
      integer steps(3)
      COMPLEX FT(NOX,NOY,NOZ)
      character *80 Buffer2
      real :: ZERO,DXM,DYM,DZM,DXM1,DYM1,DZM1,RMAX,SM
      real :: AA,BB,R,DEL,DEL1,DELta,FFF
      real :: sommaref,difxyz,ermpes
      integer :: I,IK,JH,LL,LC1,LX,LY,LZ
      integer :: IFAZ
      integer :: j,k,jk,jl,kVai,nuset
      real    :: RMSE,RMSE1,RMSE2,ERM
!
!     ZERO=0.000001
      ZERO = 0.04
      Buffer1 = ' '
      Buffer2 = ' '
      LC1=6
      do I=1,2
         dxyz(1:3) = 0.0
         DXM = 0.0
         DYM = 0.0
         DZM = 0.0
c
         DXM1 = 0.0
         DYM1 = 0.0
         DZM1 = 0.0
c
         RMAX=-9999.
         do LX=1,NOX
            do LY=1,NOY
               do LZ=1,NOZ
                  FT(LX,LY,LZ) = (0.,0.)
               enddo
            enddo
         enddo
!
         sommaref = 0
         do IK=1,mmm
            LL=IK
            if (ll.le.numbx) cycle
            if (WTexa(LL) > 0.0) then
                sommaref = sommaref + 1
                SM=+1
                if (I .EQ.2) SM=-1
                IFAZ=IPHIC(LL)
                FFF=(IPUB(LL)-SM*IFAZ)*DTOR
                AA=COS(FFF)
                BB=-SIN(FFF)
                jh = khl(1,ll)
                jk = khl(2,ll)
                jl = khl(3,ll)
                LX=MOD(JH,NOX)+1
                if (LX.LE.0)LX=LX+NOX
                LY=MOD(JK,NOY)+1
                if (LY.LE.0)LY=LY+NOY
                LZ=MOD(JL,NOZ)+1
                if (LZ.LE.0)LZ=LZ+NOZ
                FT(LX,LY,LZ)=FT(LX,LY,LZ)+CMPLX(AA,BB)
            endif
         enddo
         CALL ABC(NOX,NOY,NOZ,-1)
!
         if (ifRhombAx == nOrigRoxi) then
             do LX=1,NOX
                LY=LX
                LZ=LX
                R = REAL(FT(LX,LY,LZ))
                if (R.gt.RMAX) then
                    RMAX = R
                    dxyz(1:3) = ( float(LX)-1.0 ) / FLOAT(NOX)
                endif
             enddo
         else
             do LX=1,NOX, steps(1)
                do LY=1,NOY, steps(2)
                   do LZ=1,NOZ, steps(3)
                      dxyzi(1) = ( float(LX)-1.0 ) / FLOAT(NOX)
                      dxyzi(2) = ( float(LY)-1.0 ) / FLOAT(NOY)
                      dxyzi(3) = ( float(LZ)-1.0 ) / FLOAT(NOZ)
                      do k=1,nOrigRoxi
                         kVai = 1
                         do j=1,3
                            !if (vpol(j) == 0) then
                            if (.not.spacegr%polar(j)) then
                                difxyz = abs( dxyzi(j) - tabo(k,j) )
                                if (difxyz.gt.ZERO) then
                                    kVai = 0
                                endif
                            endif
                         enddo
                         if (kVai == 1) then
                             R = REAL(FT(LX,LY,LZ))
                             if (R.gt.RMAX) then
                                 RMAX = R
                                 dxyz = dxyzi
                             endif
                         endif
                      enddo
                   enddo
                enddo
             enddo
         endif
!
         if (if3den.eq.1) then
             do k=1,3
                !if (vpol(k) == 0) then
                if (.not.spacegr%polar(k)) then
                    if (dxyz(k).gt.0.1) then
                        if (dxyz(k).lt.0.2) then
                            dxyz(k) = 1.0 / 6.0
                        elseif (dxyz(k).lt.0.4) then
                            dxyz(k) = 1.0 / 3.0
                        elseif (dxyz(k).lt.0.6) then
                            dxyz(k) = 1.0 / 2.0
                        elseif (dxyz(k).lt.0.8) then
                            dxyz(k) = 2.0 / 3.0
                        else
                            dxyz(k) = 5.0 / 6.0
                        endif
                    endif
                endif
             enddo
         endif
         DXM = dxyz(1)
         DYM = dxyz(2)
         DZM = dxyz(3)
!
         RMSE=0.
         ERM=0.
         ermpes=0.0
         sumalfa=0.0
         ISUMAL=0
         do J=1,mmm
            LL=J
            if (ll <= numbx) cycle
            if (WTexa(LL) > 0.0) then
                ISUMAL=ISUMAL+1
                sumalfa=sumalfa+wtexa(ll)
                jh = khl(1,ll)
                jk = khl(2,ll)
                jl = khl(3,ll)
                IFAZ=IPHIC(LL)
                DELta=(JH*DXM+JK*DYM+JL*DZM)+IPUB(LL)
                DEL1=360.*DELta+IPUB(LL)-SM*IFAZ
                DEL=abs(amod(DEL1,360.))
                if (DEL > 180.0) DEL=360.-DEL
                RMSE=RMSE+DEL**2
                ERM=ERM+DEL
                ermpes=ermpes+del*wtexa(ll)
!     write(6,1000) ll,khl(1:3,ll),iphic(ll),ipub(ll),dxm,dym,dzm,delta,
!    *              del1,del,erm,ermpes
!1000 format(i4,1h),5i4,3f6.3,2f12.3,f8.3,2f15.3)
            endif
         enddo
         if (isumal == 0) then
*         write(0,*) ' isumal = 0',' nuset =',nuset,' ifmin =',ifmin
             isumal=1
             sumalfa=1.0
         endif
         RMSE=SQRT(RMSE/ISUMAL)
         ERM=ERM/ISUMAL
         ermpes=ermpes/sumalfa
         if (I.EQ.1) RMSE1=RMSE
         if (I.EQ.1) then
             ERM1=ERM
             ermpes1=ermpes
             s(1)=dxm
             s(2)=dym
             s(3)=dzm

!
             if (kmad == 0) then
                 write(Buffer1(1:40),"(i5,') ',3f5.2,2f8.2,'  ')") 
     *                 nuset,dxm,dym,dzm,erm1,ermpes1
             else
                 write(Buffer1(1:46),"(i5,') ',3f5.2,2f11.5,'  ')")
     *                 nuset,dxm,dym,dzm,erm1,ermpes1
             endif
             write(Buffer2(1:31),"(i6,')',2f9.2,'      ')") nuset,
     *                   erm1,ermpes1
c            error1(nuset,1)=erm1
             if (erm1.lt.erm1min.and.isumal.gt.nstr/2) then
                 setmin = nuset
                 erm1min = erm1
                 isumalmin=isumal
             endif
         endif
         if (I.EQ.2) RMSE2=RMSE
         if (I.EQ.2) then
             ERM2=ERM
             ermpes2=ermpes
             s(4)=dxm
             s(5)=dym
             s(6)=dzm
!
             if (kmad == 0) then
                 write(Buffer1(41:),'(3f5.2,2f8.2,i6)')
     *                      dxm,dym,dzm,erm2,ermpes2,isumal
             else
                 write(Buffer1(47:),'(3f5.2,2f11.5,i6)')
     *                      dxm,dym,dzm,erm2,ermpes2,isumal
             endif
c            error2(nuset,1)=erm2
             if (erm2.lt.erm1min.and.isumal.gt.nstr/2) then
                 setmin = -nuset
                 erm1min = erm2
                 isumalmin=isumal
             endif
         endif
         write(Buffer2(32:),'(2f9.2,i6,f9.2,i6)')
     *                   erm2,ermpes2,isumal,erm1min,nint(setmin)
         if (erm1.lt.erm2) then
             erore = erm1
             erorepes = ermpes1
         else
             erore = erm2
             erorepes = ermpes2
         end if
      enddo
      if (erm1.le.erm2) then
         do i=1,3
            shiftexam(i)=s(i)
         end do
         shiftexam(4)=1.0
      else
         do i=1,3
            shiftexam(i)=s(i+3)
         end do
         shiftexam(4)=-1.0
      end if
      if (ifmin.ne.0) then
          write(lo,'(a)') Buffer1(1:Lung(Buffer1))
!corr          call toflush()
      end if
!
      RETURN
      END
!-----------------------------------------------------------------------
      SUBROUTINE ABC(K,L,M,ISIGN)
      USE TestStuff
      COMPLEX             FX,FY,V,W,F
      DIMENSION IM(3),IN(3),ICA(3)
!
      PI = 4.0 * ATAN(1.0)
      IM(1) = K
      IM(2) = L
      IM(3) = M
      DO J=1,3
         IA=1
         IB=0
         do
            IC=IM(J)-IA
            IF (IC < 0) then
                PRINT 100,K,L,M,ISIGN
                return
            endif
            IF (IC > 0) then
                IA=IA+IA
                IB=IB+1
            else
                exit
            endif
         enddo
         IM(J)=IB
      enddo
      IF (ISIGN*ISIGN <= 0) then
          PRINT 100,K,L,M,ISIGN
          return
      endif
      CALL REV(FT,K,L,M)
      IN(1)=1
      IN(2)=2
      IN(3)=3
      DO ID=1,2
         IA=IN(1)
         IB=IN(2)
         IF (IM(IB) < IM(IA)) then
             IN(1)=IB
             IN(2)=IA
         endif
         IB=IN(2)
         IC=IN(3)
         IF (IM(IC) < IM(IB)) then
             IN(2)=IC
             IN(3)=IB
         endif
      enddo
      II=1
      II2=2
      ICC=ISIGN
      KL=K*L
      KLM=KL*M
      IK=K
      IK2=K+K
      IKL=KL
      IKL2=KL+KL
      DO J=1,3
         ICA(J)=0
         IF (IM(J) > 0) then
             ICA(J)=1
         endif
      enddo
      IA=0
      DO J=1,3
         IB=IN(J)
         IMIN=IM(IB)-IA
         IF (IMIN > 0) then
             DO IG=1,IMIN
                F=(0.0,1.0)
                F=F*(PI/ICC)
                W=CEXP(F)
                IF (ICA(1) > 0) then
                    V=(1.0,0.0)
                    DO IA=1,II
                       DO IB=IA,K,II2
                          DO IC=IB,KL,K
                             DO ID=IC,KLM,KL
                                IE=ID+II
                                FX=FT(ID)
                                FY=FT(IE)*V
                                FT(ID)=FX+FY
                                FT(IE)=FX-FY
                             enddo
                          enddo
                       enddo
                       V=V*W
                    enddo
                endif
                IF (ICA(2) > 0) then
                    V=(1.0,0.0)
                    DO IA=K,IK,K
                       DO IB=1,K
                          IF=IA+IB-K
                          DO IC=IF,KL,IK2
                             DO ID=IC,KLM,KL
                                IE=ID+IK
                                FX=FT(ID)
                                FY=FT(IE)*V
                                FT(ID)=FX+FY
                                FT(IE)=FX-FY
                             enddo
                          enddo
                       enddo
                       V=V*W
                    enddo
                endif
                IF (ICA(3) > 0) then
                    V=(1.0,0.0)
                    DO IA=KL,IKL,KL
                       DO IB=1,K
                          IF=IA+IB-KL
                          DO IC=IF,IA,K
                             DO ID=IC,KLM,IKL2
                                IE=ID+IKL
                                FX=FT(ID)
                                FY=FT(IE)*V
                                FT(ID)=FX+FY
                                FT(IE)=FX-FY
                             enddo
                          enddo
                       enddo
                       V=V*W
                    enddo
                endif
                II=II+II
                II2=II2+II2
                IK=IK+IK
                IK2=IK2+IK2
                IKL=IKL+IKL
                IKL2=IKL2+IKL2
                ICC=ICC+ICC
             enddo
         endif
         IB=IN(J)
         IA=IM(IB)
         ICA(IB)=0
      enddo
      IF (ISIGN > 0) then
          C=1.0/KLM
          DO IA=1,KLM
             FT(IA)=FT(IA)*C
          enddo
      endif
!
      RETURN
  100 FORMAT(' * ERREUR ABC * ',4I11)
      END
!-----------------------------------------------------------------------
      SUBROUTINE REV(FT,K,L,M)
      COMPLEX FT(K,L,M),F
!
      DO MA=1,M
         MM=MIR(MA-1,M)+1
         IF (MM < MA) cycle
         IF (MM > MA) then
             DO LA=1,L
                LL=MIR(LA-1,L)+1
                DO KA=1,K
                   KK=MIR(KA-1,K)+1
                   F=FT(KA,LA,MA)
                   FT(KA,LA,MA)=FT(KK,LL,MM)
                   FT(KK,LL,MM)=F
                enddo
             enddo
             cycle
         endif
         DO LA=1,L
            LL=MIR(LA-1,L)+1
            IF (LL < LA) cycle
            IF (LL > LA) then
                DO KA=1,K
                   KK=MIR(KA-1,K)+1
                   F=FT(KA,LA,MA)
                   FT(KA,LA,MA)=FT(KK,LL,MM)
                   FT(KK,LL,MM)=F
                enddo
                cycle
            endif
            DO KA=1,K
               KK=MIR(KA-1,K)+1
               IF (KK > KA) then
                   F = FT(KA, LA, MA)
                   FT(KA, LA, MA) = FT(KK, LL, MM)
                   FT(KK, LL, MM) = F
               endif
            enddo
         enddo
      enddo
!
      RETURN
      END
!-----------------------------------------------------------------------
      FUNCTION MIR(I,K)
      KA  = K
      IA  = I
      MIR = 0
      do
         IF ( ((KA - 1) * IA) <= 0 ) exit
         KA  = KA / 2
         IB  = IA / 2
         MIR = MIR + KA * (IA - IB - IB)
         IA  = IB
      enddo
!
      RETURN
      END
